SystemOrganization addCategory: #'WebBrowser-Core'!
SystemOrganization addCategory: 'WebBrowser-Core-Base'!
SystemOrganization addCategory: 'WebBrowser-Core-OS-Mac'!
SystemOrganization addCategory: 'WebBrowser-Core-OS-Unix'!
SystemOrganization addCategory: 'WebBrowser-Core-OS-Windows'!

Object subclass: #WBMacWebBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebBrowser-Core-OS-Mac'!

!WBMacWebBrowser commentStamp: 'TorstenBergmann 4/13/2016 08:24' prior: 0!
Access to the web browser on Mac!

!WBMacWebBrowser class methodsFor: 'examples' stamp: 'TorstenBergmann 4/13/2016 08:35'!
example

	self openOn: 'http://www.pharo.org'! !

!WBMacWebBrowser class methodsFor: 'instance creation' stamp: 'TorstenBergmann 4/13/2016 08:36'!
openOn: anURLString
	"
	self openOn: 'http://www.pharo.org'
	"
	| openCommand |
	openCommand := 'open "{1}"' format: { anURLString }.
	self system: openCommand.! !

!WBMacWebBrowser class methodsFor: 'private - uffi' stamp: 'TorstenBergmann 4/13/2016 09:46'!
system: command

	^ self ffiCall: #(#int #system #(#char #* #command)) module: LibC! !

Object subclass: #WBUnixWebBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebBrowser-Core-OS-Unix'!

!WBUnixWebBrowser commentStamp: 'TorstenBergmann 4/13/2016 08:24' prior: 0!
Access to the web browser on Unix!

!WBUnixWebBrowser class methodsFor: 'examples' stamp: 'TorstenBergmann 4/13/2016 08:31'!
example

	self openOn: 'http://www.pharo.org'! !

!WBUnixWebBrowser class methodsFor: 'instance creation' stamp: 'TorstenBergmann 4/13/2016 08:36'!
openOn: anURLString
	"
	self openOn: 'http://www.pharo.org'
	"
	| openCommand |
	openCommand := 'xdg-open {1} &' format: { anURLString }.
	self system: openCommand.! !

!WBUnixWebBrowser class methodsFor: 'private - uffi' stamp: 'TorstenBergmann 4/13/2016 09:45'!
system: command

	^ self ffiCall: #(#int #system #(#char #* #command)) module: LibC! !

Object subclass: #WBWindowsWebBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebBrowser-Core-OS-Windows'!

!WBWindowsWebBrowser commentStamp: 'TorstenBergmann 4/13/2016 08:24' prior: 0!
Access to the web browser on Windows!

!WBWindowsWebBrowser class methodsFor: 'examples' stamp: 'TorstenBergmann 4/13/2016 08:28'!
example

	self openOn: 'http://www.pharo.org'! !

!WBWindowsWebBrowser class methodsFor: 'instance creation' stamp: 'TorstenBergmann 4/13/2016 08:36'!
openOn: anURLString
	"
	self openOn: 'http://www.pharo.org'
	"
	^self shellExecute: 'open' file: anURLString parameters: '' directory: '' show: 5 "SW_SHOW"! !

!WBWindowsWebBrowser class methodsFor: 'private - uffi' stamp: 'TorstenBergmann 4/13/2016 09:45'!
shellExecute: lpOperation file: lpFile parameters: lpParameters directory: lpDirectory show: nShowCmd	
	
	^self ffiCall: #( 
			FFIConstantHandle ShellExecuteA(
     				0,
     				String* lpOperation,
         			String* lpFile,
     				String* lpParameters,
     				String* lpDirectory,
        			int nShowCmd)) module: #shell32! !

Object subclass: #WebBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebBrowser-Core-Base'!

!WebBrowser commentStamp: 'TorstenBergmann 4/13/2016 08:25' prior: 0!
General access to a webbrowser!

!WebBrowser class methodsFor: 'example' stamp: 'TorstenBergmann 4/13/2016 08:41'!
example

	self openOn: 'http://www.pharo.org'! !

!WebBrowser class methodsFor: 'instance-creation' stamp: 'TorstenBergmann 4/13/2016 08:40'!
openOn: aURLString
	"Open the webbrowser on the given URL"
	
	^self webbrowserClassForPlatform openOn: aURLString	
! !

!WebBrowser class methodsFor: 'private - accessing' stamp: 'TorstenBergmann 4/13/2016 08:39'!
webbrowserClassForPlatform

	Smalltalk os isUnix ifTrue: [ ^WBUnixWebBrowser ].
	Smalltalk os isWindows ifTrue: [ ^WBWindowsWebBrowser ].
	(Smalltalk os isMacOS or: [ Smalltalk os isMacOSX ])  
		ifTrue: [ ^WBMacWebBrowser ].
	self error: 'No web browser class for platform provided'
! !
